﻿Type=Activity
Version=3.8
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
	
#End Region

Sub Process_Globals
	Dim MapCenter As GeoPoint
	Dim TileSource As String
	Dim ZoomLevel As Int
	
	'	create some variables to save the MyLocationOverlay state
	Dim CompassEnabled, FollowLocationEnabled, MyLocationEnabled As Boolean
	
	
    
	Dim Timer1 As Timer
	Dim DeviceIsTablet As Boolean=False
End Sub

Sub Globals
	Dim MapView1 As MapView
	'Dim MinimapOverlay1 As MinimapOverlay
	Dim ScaleBarOverlay1 As ScaleBarOverlay
	
	'   create the SimpleLocationOverlay
   	Dim SimpleLocationOverlay1 As SimpleLocationOverlay
	
	'   create the MarkersOverlay
   	Dim MarkersOverlay1 As MarkersOverlay
	
	'	create the MyLocationOverlay
	Dim MyLocationOverlay1 As MyLocationOverlay
	Dim SpeedKmh As String
	
   	Dim acc As Double
	Dim icoFollowLocationEnabled, icoMyLocationEnabled As Button
	Dim TimerLabel As Label
	Dim TextSizeFactor As Float
	Dim periode1 As Period
	Dim TimerStart As Long
	Dim lm As LocationManager
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Timer1.Initialize("Timer1", 1000) ' 1000 = 1 second
	TimerLabel.Initialize("")
	lm.Initialize("Location")
	
	'	update the MenuItems
	Activity.AddMenuItem("Start GSMTriangulation","mnuLocation")
	Activity.AddMenuItem("Stop GSMTriangulation","mnuStopListening")
	Activity.AddMenuItem("Toggle Compass", "MenuItemSelect")
	Activity.AddMenuItem("Toggle MyLocation", "MenuItemSelect")
	Activity.AddMenuItem("Toggle FollowLocation", "MenuItemSelect")
	Activity.AddMenuItem("Exit", "MenuItemSelect")
	
#Region	
	
	'   pass an EventName when initializing the MapView
   	'   MapView has two events: CenterChanged and ZoomChanged
	MapView1.Initialize("MapView1")
	Activity.AddView(MapView1, 0, 0, 100%x, Activity.Height)
	
	MapView1.SetMultiTouchEnabled(True)
	MapView1.SetZoomEnabled(True)
	
	'	initialize and add the MyLocationOverlay to the MapView, an EventName is used as we'll be listening for all three events that this overlay generates
	MyLocationOverlay1.Initialize(MapView1, "MyLocationOverlay1")
	MapView1.AddOverlay(MyLocationOverlay1)
	
	'Set properties for my location
	'MyLocationOverlay1.PersonIcon=LoadBitmap(File.DirAssets, "mylocation.png")	' new icon!
	MyLocationOverlay1.SetCompassCenter(50,50)
	
	If FirstTime Then
	
		If Main.CenterMapUsingFirstMarker=True Then
			MapCenter.Initialize(settings.FirstMarkerLat, settings.FirstMarkerLon)
		Else
			MapCenter.Initialize(47.374037, 15.0577117)	'Leoben
			'MapCenter.Initialize(53.16794, 13.23574)   'Himmelpfort, Germany
		
		End If
		TileSource="MapquestOSM"
		
		'This can be overruled by the boundary function of the markers, comment out the function in the AddMarkers sub
		ZoomLevel=15
		
		'	set the default values for the new variables
		CompassEnabled=MyLocationOverlay1.CompassEnabled
		FollowLocationEnabled=MyLocationOverlay1.FollowLocationEnabled
		MyLocationEnabled=MyLocationOverlay1.MyLocationEnabled
	Else
		'	restore the MyLocationOverlay state
		MyLocationOverlay1.CompassEnabled=CompassEnabled
		MyLocationOverlay1.FollowLocationEnabled=FollowLocationEnabled
		MyLocationOverlay1.MyLocationEnabled=MyLocationEnabled
	End If
		
	MapView1.Zoom=ZoomLevel
	MapView1.SetCenter3(MapCenter)
	MapView1.SetTileSource(TileSource)
		
	ScaleBarOverlay1.Initialize(MapView1)
	MapView1.AddOverlay(ScaleBarOverlay1)
	ScaleBarOverlay1.SetTextSize(20)
	
	'Markers will be added if selected in the settings menu
	If Main.markers.Size>0 Then
		AddMarkers
	End If
		
	AddToggleIcons
	
	'   initialize the SimpleLocationOverlay and add it to the MapView
   	SimpleLocationOverlay1.Initialize(MapView1)
   	MapView1.AddOverlay(SimpleLocationOverlay1)
   
  	'   set the SimpleLocationOverlay to display it's icon at the map center
  	SimpleLocationOverlay1.SetMyLocation3(MapView1.GetCenter)
  'SimpleLocationOverlay1.SetMyLocation(53.16895180572086, 13.214964866638184)
	
	
	'	ensure that the MinimapOverlay is the LAST overlay added to the MapView
'	MinimapOverlay1.Initialize(MapView1)
'	MapView1.AddOverlay(MinimapOverlay1)
'	MinimapOverlay1.SetTileSource(TileSource)
	
	'Check for screen size
	If GetDevicePhysicalSize > 6 Then
     	'7'' or 10'' tablet
	  	'Log("DevicePhysicalSize="&GetDevicePhysicalSize)
		TextSizeFactor=2
		DeviceIsTablet=True
   	Else
      	'phone LG990 returns 3.887
	  	'Log("DevicePhysicalSize="&GetDevicePhysicalSize)
	  	TextSizeFactor=1.1
   	End If
	
	Activity.AddView(TimerLabel,90%x, 0, 9%x, 10%y)
	TimerLabel.Text="00:00"
	TimerLabel.TextSize=TimerLabel.TextSize*TextSizeFactor
	TimerLabel.TextColor=Colors.Black
	
	Activity.Title="OSMDroid ["&MapView1.Zoom&"]"
	MapView1.Invalidate	
	
#End Region

End Sub

Sub mnuLocation_Click
	'lm.requestGPSLocation
	lm.requestMobileLocation				'Updates roughly every 20 seconds.
	
End Sub

Sub mnuStopListening_Click
	'lm.stopGPSListening
	lm.stopMobileListening
End Sub

'Change of location, using GSM network
Sub Location_LocationChanged (Longitude As Double, Latitude As Double, Altitude As Double, Accuracy As Float, Bearing As Float, Provider As String, Speed As Float, Time As Long) 
	'Log("Longitude: " & Longitude & CRLF & "Latitude: " & Latitude & CRLF & "Altitude: " & Altitude & CRLF & "Accuracy: " & Accuracy & CRLF & "Bearing: " & Bearing & CRLF & "Speed: " & Speed& "Location")
	Log("Location changed")
	TimerLabel.Text="00:00"
	Timer1.Enabled=False
	
	SimpleLocationOverlay1.SetMyLocation(Latitude,Longitude)
	MapView1.SetCenter(Latitude,Longitude)
	
	SpeedKmh=NumberFormat2(Speed*3.6,1,0,1,False)
	acc=NumberFormat2(Accuracy,0,0,0,False)
	Activity.Title="OSMDroid ["&MapView1.Zoom&"] - Location Accuracy: "&acc&" m: Speed: "&SpeedKmh&" km/h"
	
	TimerStart=DateTime.Now
	Timer1.Enabled=True
End Sub

Sub GetDevicePhysicalSize As Float
   Dim lv As LayoutValues
   lv = GetDeviceLayoutValues
   Return Sqrt(Power(lv.Height / lv.Scale / 160, 2) + Power(lv.Width / lv.Scale / 160, 2))
End Sub

'   listen for the MapView ZoomChanged event
Sub MapView1_ZoomChanged
   'Log("MapView1_ZoomChanged ZoomLevel="&MapView1.Zoom)
   Activity.Title="OSMDroid ["&MapView1.Zoom&"]"
End Sub

'	Add markers to map
Sub AddMarkers
	'   initialize the MarkersOverlay and add it to the MapView
   	'   an EventName is required as we will listen for the two events that MarkersOverlay generates
    MarkersOverlay1.Initialize(MapView1, "MarkersOverlay1")
    MapView1.AddOverlay(MarkersOverlay1)
   
   	'   add the List of Markers to the MarkersOverlay
    MarkersOverlay1.AddMarkers(Main.markers)
   
   	'   fit the MapView to the MarkersOverlay
    'MapView1.FitMapToBoundingBox(MarkersOverlay1.GetBoundingBox)

End Sub
	
Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	MapCenter=MapView1.GetCenter
	TileSource=MapView1.GetTileSource
	ZoomLevel=MapView1.Zoom
	
	'	save the MyLocationOverlay state
	CompassEnabled=MyLocationOverlay1.CompassEnabled
	FollowLocationEnabled=MyLocationOverlay1.FollowLocationEnabled
	MyLocationEnabled=MyLocationOverlay1.MyLocationEnabled
	
	'	disable MyLocationOverlay compass and GPS listening
	MyLocationOverlay1.CompassEnabled=False
	MyLocationOverlay1.MyLocationEnabled=False
End Sub

Sub MenuItemSelect_Click
	Dim MenuItem As String
	MenuItem=Sender
	Select MenuItem
		Case "Toggle Compass"
			MyLocationOverlay1.CompassEnabled=Not(MyLocationOverlay1.CompassEnabled)
			Log("Compass enabled is " & MyLocationOverlay1.CompassEnabled)
		Case "Toggle MyLocation"
			MyLocationOverlay1.MyLocationEnabled=Not(MyLocationOverlay1.MyLocationEnabled)
			icoMyLocationEnabled.Visible=MyLocationOverlay1.MyLocationEnabled
			If MyLocationOverlay1.MyLocationEnabled=False Then
				If Timer1.Enabled=True Then Timer1.Enabled=False
				TimerLabel.Text="00:00"
			End If	
			Log("MyLocation Toggle is " & MyLocationOverlay1.MyLocationEnabled)
		Case "Toggle FollowLocation"
			MyLocationOverlay1.FollowLocationEnabled=Not(MyLocationOverlay1.FollowLocationEnabled)
			icoFollowLocationEnabled.Visible=MyLocationOverlay1.FollowLocationEnabled
			If MyLocationOverlay1.MyLocationEnabled=False Then
				'	FollowLocation will only function if MyLocation is ALSO enabled
				ToastMessageShow("FollowLocation will only function if MyLocation is ALSO enabled", True)
				If MyLocationOverlay1.MyLocationEnabled=False Then
					If Timer1.Enabled=True Then Timer1.Enabled=False
					TimerLabel.Text="00:00"
				End If	
			End If
			Log("FollowLocation Toggle is " & MyLocationOverlay1.FollowLocationEnabled)
			Timer1.Enabled=True
		Case "Exit"
			'Main.ProgramEnd=True
			Activity.Finish	
	End Select
End Sub

'	Add toggle icons
Sub AddToggleIcons
	' Initialise all buttons
   icoFollowLocationEnabled.Initialize("")
   icoMyLocationEnabled.Initialize("")
     
   ' Add bitmaps to show enabled commands
   ' dependant on the screen size
	If DeviceIsTablet=True Then
     	'7'' or 10'' tablet
	  	icoFollowLocationEnabled.SetBackgroundImage(LoadBitmap(File.DirAssets,"walk-t.png"))
   		icoMyLocationEnabled.SetBackgroundImage(LoadBitmap(File.DirAssets,"location-t.png"))
		
   	Else
      	'phone LG990 returns 3.887
	  	icoFollowLocationEnabled.SetBackgroundImage(LoadBitmap(File.DirAssets,"walk-p.png"))
   		icoMyLocationEnabled.SetBackgroundImage(LoadBitmap(File.DirAssets,"location-p.png"))
   	End If
   
         
   ' Add buttons to activity Left, Top, Width, Height
   Activity.AddView(icoMyLocationEnabled,2dip,100%y-66dip,64dip,64dip)
   Activity.AddView(icoFollowLocationEnabled,68dip,100%y-66dip,64dip,64dip)
      
   ' Turn off unused buttons
   icoFollowLocationEnabled.Visible=False
   icoMyLocationEnabled.Visible=False
	
	
   icoFollowLocationEnabled.BringToFront
   icoMyLocationEnabled.BringToFront
   
End Sub

'   two event listeners listen for the MarkersOverlay's two events
Sub MarkersOverlay1_Click(Title As String, description As String, Point As GeoPoint)
   Log("MarkersOverlay1_Click")
   ToastMessageShow(Title&": "&description, True)
End Sub

Sub MarkersOverlay1_LongClick(Title As String, description As String, Point As GeoPoint)
   Log("MarkersOverlay1_LongClick")
   ToastMessageShow(Title&": Latitude="&Point.Latitude&", Longitude="&Point.Longitude, True)
   Log(Title&": Latitude="&Point.Latitude&", Longitude="&Point.Longitude)
   '   zoom the map in and center (with animation) on the LongClicked Marker
   'MapView1.Zoom=MapView1.GetMaxZoomLevel-1
   'MapView1.AnimateTo3(Point)
End Sub

'	event listeners for the three events that MyLocationOverlay generates

Sub MyLocationOverlay1_FollowLocationAutoDisabled
	Log("MyLocationOverlay1_FollowLocationAutoDisabled")
	'	if FollowLocation is enabled and the map is dragged then FollowLocation is automatically disabled
	ToastMessageShow("FollowLocation is now DISABLED due to the map being dragged", False)
	icoFollowLocationEnabled.Visible=False
	Timer1.Enabled = True

End Sub

Sub MyLocationOverlay1_LocationChanged(NewLocation As Location, IsFirstFix As Boolean)
	TimerLabel.Text="00:00"
	Timer1.Enabled=False
	'Log("MyLocationOverlay1_LocationChanged, Latitude="&NewLocation.Latitude&", Longitude="&NewLocation.Longitude&", IsFirstFix="&IsFirstFix)
	SimpleLocationOverlay1.SetMyLocation2(NewLocation)
	MapView1.SetCenter2(NewLocation)
	SpeedKmh=NumberFormat2( NewLocation.Speed*3.6,1,0,1,False)
	acc=NumberFormat2(NewLocation.Accuracy,0,0,0,False)
	Activity.Title="OSMDroid ["&MapView1.Zoom&"] - GPS Accuracy: "&acc&" m: Speed: "&SpeedKmh&" km/h"
	TimerStart=DateTime.Now
	Timer1.Enabled=True
	
End Sub

Sub MyLocationOverlay1_ProviderChanged(Provider As String, Enabled As Boolean)
	'	note that i have yet to see this event generated
	'Log("MyLocationOverlay1_ProviderChanged, Provider="&Provider&", Enabled="&Enabled)
End Sub

Sub Timer1_Tick
   	'Handle tick events
   	If TimerStart>0 Then	'Only active after a first fix
   		periode1 = DateUtils.PeriodBetween( TimerStart,DateTime.Now)
   		'Log("Now=:"&DateTime.Now)
   		'Log("Timerstart:"&TimerStart)
   		'Log("Period:"&periode1.Minutes & ":" & NumberFormat2(periode1.Seconds,2,0,0,False))
   		TimerLabel.Text=periode1.Minutes & ":" & NumberFormat2(periode1.Seconds,2,0,0,False)
	End If
End Sub

