﻿Type=Activity
Version=3.8
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim parser As SaxParser
	
	Dim FirstMarkerLat, FirstMarkerLon As Double
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim lblLocation,lblUseGPS,lblUseWIFI, lblUse3G  As Label
	Dim UseGPS, UseWIFI, UseGSM, UseGPX As CheckBox
	Dim lblGPSFile, lblCenterFirstMarker, lblKeepAlive As Label
	Dim UseFirstMarker, UseKeepAlive As CheckBox
	Dim btnBack As Button
	
	Dim svMaster As ScrollView
	Dim pnl As Panel
	
	Dim fd As FileDialog
	Dim lati As String
    Dim loni As String
	Dim desc As String
	Dim Icon As BitmapDrawable
	
	Dim gd1, gd2 As GradientDrawable
	Dim cols1(2) As Int
	Dim TextScale As Float
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("settings")
	
	Build_GUI
	
	Select Main.LocationDetect
	Case 0
		UseGPS.Checked=True
		UseWIFI.Checked=False
		UseGSM.Checked=False
	Case 1
		UseGPS.Checked=False
		UseWIFI.Checked=True
		UseGSM.Checked=False
	Case 2
		UseGPS.Checked=False
		UseWIFI.Checked=False
		UseGSM.Checked=True
	End Select
	
	UseFirstMarker.Checked=Main.CenterMapUsingFirstMarker
	
	parser.Initialize	'initialise the parser
	
	
	Icon.Initialize(LoadBitmap(File.DirAssets, "tent.png"))	' Load file for poi icon
End Sub

Sub Build_GUI
	svMaster.Initialize(Activity.Height*2)
	pnl=svMaster.Panel
	
	'Get textscale factor
	TextScale=(GetDeviceLayoutValues.Width/GetDeviceLayoutValues.Height)-0.3
	
'	Log(GetDeviceLayoutValues.ApproximateScreenSize)
'	Log(GetDeviceLayoutValues.Height)
'	Log(GetDeviceLayoutValues.Scale)
'	Log(GetDeviceLayoutValues.Width)
'	Log("TextScale " & TextScale)
	
	'Prepare gradient
	cols1(0) = Colors.ARGB(255,167,221,241)
	cols1(1) = Colors.White
	gd1.Initialize( "BOTTOM_TOP",cols1)
	gd2.Initialize( "TOP_BOTTOM",cols1)
	gd1.CornerRadius=0
	gd2.CornerRadius=0
	Activity.Background=gd2
	svMaster.Background=gd2
	
	'Prepare labels
	lblLocation.Initialize("")
	lblUseGPS.Initialize("")
	lblUseWIFI.Initialize("")
	lblUse3G.Initialize("")
	lblGPSFile.Initialize("")
	lblCenterFirstMarker.Initialize("")
	lblKeepAlive.Initialize("")
	
	lblLocation.Background=gd1
	lblUseGPS.Background=gd1
	lblUseWIFI.Background=gd1
	lblUse3G.Background=gd1
	lblGPSFile.Background=gd1
	lblCenterFirstMarker.Background=gd1
	lblKeepAlive.Background=gd1
	
	'Prepare checkboxes
	UseGPS.Initialize("UseGPS")
	UseGSM.Initialize("UseGSM")
	UseWIFI.Initialize("UseWIFI")
	UseGPX.Initialize("UseGPX")
	UseFirstMarker.Initialize("UseFirstMarker")
	UseKeepAlive.Initialize("UseKeepAlive")
	UseKeepAlive.Checked=Main.KeepScreenAlive
			
	'Label text
	lblLocation.Text="  Use for location:"
	lblUseGPS.Text="       GPS"
	lblUseWIFI.Text="       WIFI"
	lblUse3G.Text="       3G"
	lblGPSFile.Text="  Click checkbox to add gpx data"
	lblCenterFirstMarker.Text="  Center map on first marker?"
	lblKeepAlive.Text="  Keep screen turned on"
	lblLocation.TextColor=Colors.Black
	lblUseGPS.TextColor=Colors.Black
	lblUseWIFI.TextColor=Colors.Black
	lblUse3G.TextColor=Colors.Black
	lblGPSFile.TextColor=Colors.Black
	lblCenterFirstMarker.TextColor=Colors.Black
	lblKeepAlive.TextColor=Colors.Black
	lblLocation.TextSize=lblLocation.TextSize*TextScale
	lblUseGPS.TextSize=lblUseGPS.TextSize*TextScale
	lblUseWIFI.TextSize=lblUseWIFI.TextSize*TextScale
	lblUse3G.TextSize=lblUse3G.TextSize*TextScale
	lblGPSFile.TextSize=lblGPSFile.TextSize*TextScale
	lblCenterFirstMarker.TextSize=lblCenterFirstMarker.TextSize*TextScale
	lblKeepAlive.TextSize=lblKeepAlive.TextSize*TextScale
		
	'Add labels
	pnl.AddView(lblLocation,15dip,10dip,385dip,35dip)
	pnl.AddView(lblUseGPS,15dip,60dip,380dip,35dip)
	pnl.AddView(lblUseWIFI,15dip,110dip,380dip,35dip)
	pnl.AddView(lblUse3G,15dip,160dip,380dip,35dip)
	pnl.AddView(lblGPSFile,15dip,210dip,380dip,35dip)
	pnl.AddView(lblCenterFirstMarker,15dip,260dip,380dip,35dip)
	pnl.AddView(lblKeepAlive,15dip,310dip,380dip,35dip)
	
	'Add checkboxes
	pnl.AddView(UseGPS,360dip,60dip,50dip,40dip)
	pnl.AddView(UseWIFI,360dip,110dip,50dip,40dip)
	pnl.AddView(UseGSM,360dip,160dip,50dip,40dip)
	pnl.AddView(UseGPX,360dip,210dip,50dip,40dip)
	pnl.AddView(UseFirstMarker,360dip,260dip,50dip,40dip)
	pnl.AddView(UseKeepAlive,360dip,310dip,50dip,40dip)
	
	'Activity.AddView(svMaster, 0, 0, 100%x,100%y-70dip)
	Activity.AddView(svMaster, 0, 0, 100%x,100%y)
	
	'Buttons
	Dim bmd As BitmapDrawable
	bmd.Initialize(LoadBitmap(File.DirAssets, "back.png"))
	btnBack.Initialize("btnBack")
	btnBack.Background = bmd
	Activity.AddView(btnBack, 5dip, 100%y-69dip, 64dip,64dip)
End Sub


Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub UseWIFI_CheckedChange(Checked As Boolean)
	If UseWIFI.Checked Then
		UseGSM.Checked=False
		UseGPS.Checked=False
		Main.LocationDetect=1
		
	End If
	
End Sub
Sub UseGSM_CheckedChange(Checked As Boolean)
	If UseGSM.Checked Then
		UseGPS.Checked=False
		UseWIFI.Checked=False
		Main.LocationDetect=2
		
	End If
End Sub
Sub UseGPS_CheckedChange(Checked As Boolean)
	If UseGPS.Checked Then
		UseGSM.Checked=False
		UseWIFI.Checked=False
		Main.LocationDetect=0
	End If
End Sub

Sub UseKeepAlive_CheckedChange(Checked As Boolean)
	Dim awake As PhoneWakeState
	If Main.KeepScreenAlive=True Then
		awake.ReleaseKeepAlive
		Main.KeepScreenAlive=False
	Else
		awake.KeepAlive(True)
		Main.KeepScreenAlive=True
	End If	

End Sub

Sub btnBack_Click
	Activity.Finish
End Sub

'The following subs deal with waypoint files
Sub UseGPX_CheckedChange(Checked As Boolean)
	
	fd.FastScroll = True
    fd.FilePath =File.DirRootExternal
    fd.FileFilter = ".gpx" 
	fd.KeyboardPopUp=False
    ret = fd.Show( "Choose a .gpx file", "Ok", "Cancel", "", Null)   
    If ret=-1 Then
        Log(fd.FilePath & fd.ChosenName)  'just to see what is included in the file
		lblGPSFile.Text=fd.FilePath & fd.ChosenName
    Else
		UseGPX.Checked=False
        Return	'no file selected
    End If  

	'Open gpx File AND parse
    Dim In As InputStream
    In = File.OpenInput(fd.FilePath,fd.ChosenName)
    parser.Parse(In, "Parser")
    In.Close

End Sub

Sub UseFirstMarker_CheckedChange(Checked As Boolean)
	Main.CenterMapUsingFirstMarker=UseFirstMarker.Checked
End Sub


'	Required for parser
Sub Parser_StartElement (Uri As String, Name As String, Attributes As Attributes)
    If Name="wpt"  Then
        lati = Attributes.GetValue2("","lat") 
        'Log(lati) 
        loni = Attributes.GetValue2("","lon") 
        'Log(loni)
    End If
End Sub

'	Required for parser
Sub Parser_EndElement (Uri As String, Name As String, Text As StringBuilder)
    If Name="name" AND lati.Length>0 Then
		desc=Text.ToString
		'Log(description)
		Dim Marker As Marker
		Marker.Initialize("Waypoint", desc, lati, loni, Icon)
		Main.markers.Add(Marker)
		
		If Main.markers.Size=1 Then
			FirstMarkerLat=lati
			FirstMarkerLon=loni
		End If
		
	End If
End Sub

